/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ThoracicTissueSegmentationTypes;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ThoracicTissueSegmentationTypes;


/**
 * This class represents ThoracicTissueSegmentationTypes CID7155
 */
public class ThoracicTissueSegmentationTypes_CID7155 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new ThoracicTissueSegmentationTypes_CID7155 Template 
	 */
	public ThoracicTissueSegmentationTypes_CID7155()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumThoracicTissueSegmentationTypes Object of EnumCM_ThoracicTissueSegmentationTypes represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ThoracicTissueSegmentationTypes enumThoracicTissueSegmentationTypes)
	{
		switch(enumThoracicTissueSegmentationTypes) 
 {
		case BLOOD_VESSEL:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.BLOOD_VESSEL_T_40000
					.getValue();
			break;
		case BONE_OF_THORAX:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.BONE_OF_THORAX_T_D0170
					.getValue();
			break;
		case BRONCHUS:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.BRONCHUS_T_26000
					.getValue();
			break;
		case CHEST_WALL_MUSCLE:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.CHEST_WALL_MUSCLE_T_14122
					.getValue();
			break;
		case CLAVICLE:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.CLAVICLE_T_12310
					.getValue();
			break;
		case DIAPHRAGM:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.DIAPHRAGM_T_D3400
					.getValue();
			break;
		case ESOPHAGUS:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.ESOPHAGUS_T_56000
					.getValue();
			break;
		case LOWER_LOBE_OF_LUNG:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.LOWER_LOBE_OF_LUNG_T_28830
					.getValue();
			break;
		case LUNG:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.LUNG_T_28000
					.getValue();
			break;
		case MEDIASTINUM:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.MEDIASTINUM_T_D3300
					.getValue();
			break;
		case MIDDLE_LOBE_OF_RIGHT_LUNG:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.MIDDLE_LOBE_OF_RIGHT_LUNG_T_28300
					.getValue();
			break;
		case PLEURA:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.PLEURA_T_29000
					.getValue();
			break;
		case RIB:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.RIB_T_11300
					.getValue();
			break;
		case SKIN_OF_CHEST:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.SKIN_OF_CHEST_T_02424
					.getValue();
			break;
		case STERNUM:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.STERNUM_T_11210
					.getValue();
			break;
		case THORACIC_SPINE:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.THORACIC_SPINE_T_11502
					.getValue();
			break;
		case THORAX:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.THORAX_T_D3000
					.getValue();
			break;
		case TRACHEA:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.TRACHEA_T_25000
					.getValue();
			break;
		case THYMUS:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.THYMUS_T_C8000
					.getValue();
			break;
		case UPPER_LOBE_OF_LUNG:
			this.strCodeValue = EnumCV_ThoracicTissueSegmentationTypes.UPPER_LOBE_OF_LUNG_T_28820
					.getValue();
			break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumThoracicTissueSegmentationTypes Object of EnumCM_ThoracicTissueSegmentationTypes represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_ThoracicTissueSegmentationTypes enumThoracicTissueSegmentationTypes)
	{
		switch(enumThoracicTissueSegmentationTypes)
 {
		case BLOOD_VESSEL:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.BLOOD_VESSEL
					.getSNOMEDCTID();
			break;
		case BONE_OF_THORAX:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.BONE_OF_THORAX
					.getSNOMEDCTID();
			break;
		case BRONCHUS:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.BRONCHUS.getSNOMEDCTID();
			break;
		case CHEST_WALL_MUSCLE:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.CHEST_WALL_MUSCLE
					.getSNOMEDCTID();
			break;
		case CLAVICLE:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.CLAVICLE.getSNOMEDCTID();
			break;
		case DIAPHRAGM:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.DIAPHRAGM.getSNOMEDCTID();
			break;
		case ESOPHAGUS:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.ESOPHAGUS.getSNOMEDCTID();
			break;
		case LOWER_LOBE_OF_LUNG:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.LOWER_LOBE_OF_LUNG
					.getSNOMEDCTID();
			break;
		case LUNG:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.LUNG.getSNOMEDCTID();
			break;
		case MEDIASTINUM:
			this.strSNOMEDCTID = EnumChestCardiacSNOMEDMap.MEDIASTINUM.getSNOMEDCTID();
			break;
		case MIDDLE_LOBE_OF_RIGHT_LUNG:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.MIDDLE_LOBE_OF_RIGHT_LUNG
					.getSNOMEDCTID();
			break;
		case PLEURA:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.PLEURA.getSNOMEDCTID();
			break;
		case RIB:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.RIB.getSNOMEDCTID();
			break;
		case SKIN_OF_CHEST:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.SKIN_OF_CHEST
					.getSNOMEDCTID();
			break;
		case STERNUM:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.STERNUM.getSNOMEDCTID();
			break;
		case THORACIC_SPINE:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.THORACIC_SPINE
					.getSNOMEDCTID();
			break;
		case THORAX:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.THORAX.getSNOMEDCTID();
			break;
		case TRACHEA:
			this.strSNOMEDCTID = EnumAnatomicSNOMEDMap.TRACHEA.getSNOMEDCTID();
			break;
		case THYMUS:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.THYMUS.getSNOMEDCTID();
			break;
		case UPPER_LOBE_OF_LUNG:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.UPPER_LOBE_OF_LUNG
					.getSNOMEDCTID();
			break;
		}
	}

	/**
	 * Sets the value for ThoracicTissueSegmentationTypes
	 * @param enumThoracicTissueSegmentationTypes Object of EnumCM_ThoracicTissueSegmentationTypes.
	 */
	public void setThoracicTissueSegmentationTypes(EnumCM_ThoracicTissueSegmentationTypes enumThoracicTissueSegmentationTypes)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumThoracicTissueSegmentationTypes.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumThoracicTissueSegmentationTypes);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumThoracicTissueSegmentationTypes);
	}
}
